import { Component } from 'react';
import {MultiSelect} from 'primereact/multiselect';
import _ from 'lodash';

export default class SkySllector extends Component {
  constructor(props) {
    super(props);
          
    this.dropDownOptions= [];
    this.state= {
      dropDownValues: [],
      dropDownOptions: [],
    }
    this.field = ''
    this.callbackUpdateCell = this.callbackUpdateCell.bind(this);
  }

  async componentDidMount(){
    let selectedValues = null;
    if (this.props.colDef.field.startsWith('gdef_')) {
        let fields = _.split(this.props.colDef.field, 'gdef_')
        this.field = fields[1]
        selectedValues = this.props.data[this.props.colDef.field];
    }
    else {
        selectedValues = this.props.data[this.props.colDef.field];
        this.field = this.props.colDef.field
    }
    let tmpDailyValue = [];
    if(selectedValues  && selectedValues.length>0){
        tmpDailyValue = _.split(selectedValues, ",");
    }
    await this.setState({
      dropDownValues: tmpDailyValue,
      dropDownOptions: this.props.context.componentParent.state.multiSelectorOptions[this.field]
    });
  }

  async callbackUpdateCell(e) {
    this.setState({
      dropDownValues: e.value
    })
    let displayText = '';
    let selectedValues = e.value;
    await selectedValues.forEach( key =>{
      displayText += key+",";
    })
    displayText = _.trim(displayText)
    displayText = displayText.replace(/,([^,]*)$/, '' + '$1')   
  
    this.props.context.componentParent.updateCell(
        this.props.node.rowIndex, this.props.colDef.field, displayText === ''? [] : _.split(displayText, ","), true
    );
     
  }
 
  afterGuiAttached(){
   // this.input.input.focus();
  }
  isPopup() {
    return true;
  }
  render() {
    return (
        <div className="col-sm-6">
            {this.state.dropDownOptions && this.state.dropDownOptions.length > 0 && 
                <MultiSelect  optionLabel="name"   value={this.state.dropDownValues} options={this.state.dropDownOptions
                }
                optionValue="value" filter={true}
                onChange={this.callbackUpdateCell}
                />
            }
        </div>
    );
  }
}