import FailureBusinessTemplate from './failure.business.template';
import html2canvas from 'html2canvas';
import moment from 'moment';
import jsPDF from 'jspdf';
const FailureBusinessPdf = {

    

    writeRow: function (pdf, row, y) {
        pdf.setDrawColor(200, 200, 200);
        pdf.line(5, y - 3, 287, y - 3);
        pdf.line(89, y - 3, 89, y +2 );
        pdf.line(106, y - 3, 106, y +2);
        pdf.line(120, y - 3, 120, y +2);
        pdf.line(142, y - 3, 142, y +2);
        pdf.line(159, y - 3, 159, y +2);
        pdf.line(180, y - 3, 180, y +2);
        pdf.line(199, y - 3, 199, y +2);
        pdf.setTextColor(20, 20, 30);
        pdf.text(5, y, row.name);
        pdf.text(90, y, row.project);
        pdf.text(107, y, row.status);
        pdf.text(121, y, FailureBusinessTemplate.on_sky_start_time_Template(row));
        pdf.text(143, y, FailureBusinessTemplate.on_sky_duration_Template(row));
        pdf.text(160, y, FailureBusinessTemplate.issues_Template(row));
        pdf.text(181, y, FailureBusinessTemplate.issuessubtypes_Template(row));
        pdf.text(200, y, FailureBusinessTemplate.subtasks_Template(row));
    },

    writeheaderrow: function (pdf) {
        pdf.setFont("courier", "bold");
        const ypos = 5;
        pdf.text(5, ypos, "Name");
        pdf.text(90, ypos, "Project");
        pdf.text(107, ypos, "Status");
        pdf.text(121, ypos, "On Sky ");
        pdf.text(143, ypos, "Sky duration");
        pdf.text(160, ypos, "Issues");
        pdf.text(181, ypos, "Subissues");
        pdf.text(200, ypos, "SubTasks");
        pdf.setFont("courier", "normal");
    },

    writeTable: function (pdf, failureReport) {

        let rowline = 10;
        const lineheight = 5;
        const maxheight = 210;
        if (!failureReport?.failed_scheduling_units) return
        for (let row of failureReport.failed_scheduling_units) {
            if (rowline == 10) {
                pdf.addPage('l', 'mm', [297, maxheight]);
                this.writeheaderrow(pdf);
            }
            this.writeRow(pdf, row, rowline)
            rowline += lineheight;
            if (rowline > (maxheight - lineheight)) rowline = 10;
        }
    },
     GeneratePdf: async function (failureReport,dates) {
        
        // Create a PDF document with landscape orientation, 1st report div width and the max height of all report divs in pixels
        const pdf = new jsPDF('l', 'mm', [297, 210]);
        let title = `${moment(dates[0]).format("DD MMM YYYY")} - ${moment(dates[1]).format("DD MMM YYYY")}`
        // Draw each report in canvas and create image of the canvas before saving the pdf
        pdf.setFontSize(12);
        pdf.text(10, 10, 'Failure Report ' + title + " page 1");
        await addelement("chart1", 0, 20);
        await addelement("chart2", 100, 20);
        await addelement("chart3", 0, 120);
        await addelement("chart4", 100, 120);
        await addelement("chart5", 200, 20);
        await addelement("chart6", 200, 120);
        pdf.addPage('l', 'mm', [297, 210]);
        pdf.text(10, 10, 'Failure Report ' + title + " page 2");
        await addelement("chart8", 200, 20);
        await addSizedElement("chart7", 20, 50, 2, 2);
        pdf.setFontSize(5);
        this.writeTable(pdf,failureReport);
        pdf.save(`FailureReport_${title}.pdf`);


        async function addelement(elementname, x, y) {
            return addSizedElement(elementname, x, y, 2, 3);
        }


        async function addSizedElement(elementname, x, y, sizeAdder, canvasdivider) {
            let element = document.getElementById(elementname);
            const options = {
                foreignObjectRendering: true,
                width: element?.clientWidth * sizeAdder,
                height: element?.clientHeight * sizeAdder
            };

            let canvas = await html2canvas(element, options);
            if (canvas!==undefined) {
                let dataurl = canvas.toDataURL('image/jpeg');
                if (dataurl!==null)
                pdf.addImage(dataurl, 'JPEG', x, y, element.clientWidth / canvasdivider, element.clientHeight / canvasdivider);
            }
        }
    }
}
export default FailureBusinessPdf;
