import 'leaflet/dist/leaflet.css'
import {MapContainer, Marker,  TileLayer } from 'react-leaflet'
import L from 'leaflet'
import { useMap } from 'react-leaflet'



delete L.Icon.Default.prototype._getIconUrl;


L.Icon.Default.mergeOptions({
  iconRetinaUrl: require('leaflet/dist/images/marker-icon-2x.png'),
  iconUrl: require('leaflet/dist/images/marker-icon.png'),
  shadowUrl: require('leaflet/dist/images/marker-shadow.png')
});

function GetMapComponent(props) {
    const {
        mapRef
    } = props
      const map = useMap()
      setTimeout(() => { mapRef(map)},0);
    return null
  }

function StationGeoView(props) {
    const {
        stations,
        mapRef
    } = props



    return (
    <div className="GeoBlock">
        
      <MapContainer
        className="full-screen-map"
        center={[52.91512333474063, 6.869839092349391]}
        zoom={6}
        minZoom={3}
        maxZoom={19}
        maxBounds={[[-85.06, -180], [85.06, 180]]}
        scrollWheelZoom={true}>
        <TileLayer
        
          url="https://tile.openstreetmap.org/{z}/{x}/{y}.png"
        />
         
        {stations.map((station ) => {
          const markerPosition = [
            station.geometry.coordinates[1],
            station.geometry.coordinates[0],
          ];

          const customIcon = new L.divIcon({
            className: 'custom-marker-icon',
            html: `
            <div >
              <div class="marker-circle ${station.properties.className}"></div>
              <div class="marker-text">${station.properties.name}</div>
            </div>
          `,
          });

          return (
            <Marker
              key={station.id}
              position={markerPosition}
              icon={customIcon}>
             
            </Marker>
          );
        })}
        <GetMapComponent mapRef={mapRef}/>
      </MapContainer>
    </div>
  );
}

export default StationGeoView;
