

import AuthUtil from '../../utils/auth.util';
import AccessDenied from '../../layout/components/AccessDenied';
import  { TaskEditSecure}   from './edit.secure';
import { useEffect, useState } from 'react';




const TaskEdit = ({ history,match,taskId,location}) => {

    
    const [isLoading, setIsLoading] = useState(true);
    const [userrole, setUserrole] = useState({});
    const [requistedTaskId, setRequistedTaskId] = useState("");
    
    const init = async () => {
        let calculatedTaskId =  match.params?.id ?? taskId ?? location.state?.taskId ?? null;
        let permission = await AuthUtil.getUserPermissionByModuleId('task_draft', calculatedTaskId);
        console.log("Load Permissions",permission,calculatedTaskId)
        setRequistedTaskId(calculatedTaskId);
        setUserrole(permission);
        setIsLoading(false);
    }


    useEffect(() => {
        init();
    }, []);




    const RenderPage = () => {
        try
        {
            if (isLoading) return 
            if (!userrole[requistedTaskId]?.edit )     return <div> For TaskId {requistedTaskId} <AccessDenied /></div>
            return <TaskEditSecure userrole={userrole} taskId={requistedTaskId} history={history}  /> 
        }
        catch(e){
            console.log(e);
            return <div> Error Rendering Page</div>
        }
    }

    return RenderPage();

}
export default TaskEdit