import UIConstants from "../utils/ui.constants";

const TimelineConstants = {
    SU_LIST_DEFAULT_COLUMNS: [{
        status: {
            name: "Status",
            filter: "multiselect-filter",
            showTag: true,
            tagClass: 'su-$dynamic$' //$dynamic$ will be replace with cell value
        },
        start_time:
            {
                name: "Start Time",
                format: UIConstants.CALENDAR_DATETIME_FORMAT
            },
        stop_time: {
            name: "End Time",
            format: UIConstants.CALENDAR_DATETIME_FORMAT
        },
        duration: {
            name: "Duration (HH:mm:ss)"
        },
        id: {
            name: "Id"
        },
        name: {
            name: "Name"
        },
        rank: {
            name: "Rank"
        },
        project: {
            name: "Project"
        },
        project_rank: {
            name: "Project Rank"
        },
        priority_queue_value: {
            name: "Priority Queue"
        },
        stationGroupCount: {
            name: "Stations (CS/RS/IS)"
        }
    }],
    UNSCEDULABLE_SU_LIST_DEFAULT_COLUMNS: [{
        viewSummaryAction: {
            name: "View Summary",
            filter: "none",
            disableSortBy: true
        },
        unschedulable_reason: {
            name: "Unschedulable Reason",
        },
        start_time:
            {
                name: "Start Time",
                format: UIConstants.CALENDAR_DATETIME_FORMAT
            },
        stop_time: {
            name: "End Time",
            format: UIConstants.CALENDAR_DATETIME_FORMAT
        },
        duration: {
            name: "Duration (HH:mm:ss)"
        },
        id: {
            name: "Id"
        },
        name: {
            name: "Name"
        },
        rank: {
            name: "Rank"
        },
        project: {
            name: "Project"
        },
        project_rank: {
            name: "Project Rank"
        },
        priority_queue_value: {
            name: "Priority Queue"
        },
        stationGroupCount: {
            name: "Stations (CS/RS/IS)"
        }
    }],
    SU_LIST_OPTIONAL_COLUMNS: [{
        description: {
            name: "Description"
        },
        task_content: {
            name: "Task content"
        },
        observ_template_name: {
            name: "Template name"
        },
        updated_at: {
            name: "Updated At",
            format: UIConstants.CALENDAR_DATETIME_FORMAT
        },
        do_cancel: {
            name: "Cancelled"
        },
        workflowStatus: {
            name: "Workflow Status"
        },
        results_accepted: {
            name: "Data Accepted"
        },
        actionpath: "actionpath"
    }],
    SU_LIST_COLUMN_ORDER: [
        "View Summary",
        "Status",
        "Unschedulable Reason",
        "Start Time",
        "End Time",
        "Duration (HH:mm:ss)",
        "Id", "Name",
        "Description",
        "Project Rank",
        "Rank",
        "Project",
        "Priority Queue",
        "Stations (CS/RS/IS)",
        "Template name",
        "Data Accepted",
        "Cancelled",
        "Workflow Status",
        "Task content"
    ],
    SU_LIST_COLUMN_CLASSES: [{
        "Cancelled": "filter-input-50", "Status": "filter-input-100",
        "Start Time": "filter-input-75", "End Time": "filter-input-75",
        "Id": "filter-input-50", "Name": "filter-input-150", "View Summary": "filter-input-0",
        "Workflow Status": "filter-input-75", "description": "filter-input-125",
        "Project Rank": "filter-input-50", "Project": "filter-input-75",
        "Stations (CS/RS/IS)": "filter-input-75", "Task content": "filter-input-75",
        "Duration (HH:mm:ss)": "filter-input-50", "Template Name": "filter-input-75"
    }],
    TASK_LIST_DEFAULT_COLUMNS: [{
        status: {
            name: "Status", filter: "multiselect-filter",
            showTag: true,
            tagClass: 'su-$dynamic$' //$dynamic$ will be replace with cell value
        },
        project: {
            name: "Project"
        },
        task_type: {
            name: "Task Type",
            filter: "multiselect-filter",
        },
        start_time: {
            name: "Start Time",
            format: UIConstants.CALENDAR_DATETIME_FORMAT
        },
        stop_time: {
            name: "End Time",
            format: UIConstants.CALENDAR_DATETIME_FORMAT
        },
        duration: {
            name: "Duration (HH:mm:ss)"
        },
        id: {
            name: "Task Id"
        },
        name: {
            name: "Name"
        },
        short_description: {
            name: "Short Description"
        },
        controlId: {
            name: "Control Id"
        },
        suId: {
            name: "Scheduling Unit Id"
        },
        dataSizeOnDisk: {
            name: "Data Size on Disk (TB)"
        }
    }],
    TASK_LIST_OPTIONAL_COLUMNS: [{
        statusLogs: {
            name: "Status Logs",
            filter: 'none'
        },
        suName: {
            name: "Scheduling Unit Name"
        },
        description: {
            name: "Description"
        },
        dataProducts: {
            name: "#Dataproducts"
        },
        dataSize: {
            name: "Data Size (TB)"
        },
        subtaskContent: {
            name: "Subtask Content"
        },
        updated_at: {
            name: "Updated At",
            format: UIConstants.CALENDAR_DATETIME_FORMAT
        },
        obsolete_since: {
            name: "Obsolete",
            filter: "switch"
        },
        do_cancel: {
            name: "Cancelled"
        },
        actionpath: "actionpath"
    }],
    TASK_LIST_COLUMN_ORDER: [
        "Status Logs",
        "Status",
        "Unschedulable Reason",
        "Task Type",
        "Start Time",
        "End Time",
        "Duration (HH:mm:ss)",
        "Task Id",
        "Name",
        "Control Id",
        "Project",
        "Scheduling Unit Id",
        "Scheduling Unit Name",
        "Description",
        "Short Description",
        "#Dataproducts",
        "Data Size (TB)",
        "Data Size on Disk (TB)",
        "Subtask Content",
        "Updated At",
        "Obsolete",
        "Cancelled"
    ],
    TASK_LIST_COLUMN_CLASSES: [{
        "Status Logs": "filter-input-0", "Type": "filter-input-100",
        "Status": "filter-input-100", "Cancelled": "filter-input-50",
        "Start Time": "filter-input-75", "End Time": "filter-input-75",
        "Task Id": "filter-input-50", "Name": "filter-input-100",
        "Control Id": "filter-input-75", "Description": "filter-input-125",
        "Scheduling Unit Id": "filter-input-50", "Scheduling Unit Name": "filter-input-150",
        "#Dataproducts": "filter-input-50", "Subtask Content": "filter-input-50",
        "Duration (HH:mm:ss)": "filter-input-75", "Data Size (TB)": "filter-input-50",
        "Data Size on Disk (TB)": "filter-input-50", "Updated At": "filter-input-75"
    }],
    RES_LIST_DEFAULT_COLUMNS: [{
        name: {
            name: "System Id"
        },
        description: {
            name: "Description"
        },
        start_time: {
            name: "Start Time",
            format: UIConstants.CALENDAR_DATETIME_FORMAT
        },
        stop_time: {
            name: "End Time",
            format: UIConstants.CALENDAR_DATETIME_FORMAT
        },
        duration: {
            name: "Duration (Days HH:mm:ss)"
        },
        activityType: {
            name: "Reservation Type"
        },
        activitySubject: {
            name: "Subject"
        },
        activityPlanned: {
            name: "Planned"
        },
        stations: {
            name: "Stations"
        },
        scheduleFixedTime: {
            name: "FixedTime"
        },
        scheduleDynamic: {
            name: "Dynamic"
        },
        fixedProject: {
            name: "Fixed Project"
        },
        project_id: {
            name: "Project"
        },
        effectsExpert: {
            name: "Expert"
        },
        effectsHBARfi: {
            name: "HBA-RFI"
        },
        effectsLBARfi: {
            name: "LBA-RFI"
        }
    }],
    RES_LIST_OPTIONAL_COLUMNS: [{
        actionpath: "actionpath"
    }],
    RES_LIST_COLUMN_ORDER: [
        "System Id",
        "Description",
        "Start Time"
    ],
    RES_LIST_COLUMN_CLASSES: [{
        "Start Time": "filter-input-75", "End Time": "filter-input-75",
        "Duration (Days HH:mm:ss)": "filter-input-75",
        "Reservation Type": "filter-input-100",
        "Subject": "filter-input-75", "Planned": "filter-input-50",
        "Stations": "filter-input-100", "FixedTime": "filter-input-50",
        "Dynamic": "filter-input-50", "Fixed Project": "filter-input-50",
        "Expert": "filter-input-50", "HBA-RFI": "filter-input-50",
        "LBA-RFI": "filter-input-50", "Project": "filter-input-100"
    }]
};

export default TimelineConstants;